#!/usr/bin/python
# -*- coding: <UTF-8> -*-

"""
Python Version : 3.6

$LastChangedRevision: 3465 $
$LastChangedDate:: 2020-08-25 09:49:49 +0200#$

This file is part of SyMSpace.

Copyright (c) 2019, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
All rights reserved.
"""
# Todo: is this file obsolete so it can be removed?

from symspace.wrapper.symwrapper import *


def testUnresolved(obj, tstparam, unresolved, scorelst):
    obj.addParam(tstparam)

    score = 0
    for item in unresolved:
        tstparam.setImportAssignments({'link': item[1].getParamName()})
        if tstparam.getImports()[0].getHandle() is not None:
            score += 1

    # print('Score for {}: {}'.format(obj.getIdentifier(), score))
    if score > 0:
        scorelst.append([obj, score, obj.getIdentifier().count('.')])

    for par in obj.getParam():
        if isinstance(par, SymContainer):
            testUnresolved(par, tstparam, unresolved, scorelst)


def addComponent(prj, comp):
    lstcomp = []
    allcomps = SymComponentInfo.getComponents()
    for item in allcomps:
        if comp.lower() in item.lower():
            lstcomp.append(item)

    if len(lstcomp) == 0:
        print('No Component found:')
        ret = []
    elif len(lstcomp) > 1:
        print('Select form the following Components:')
        for item in lstcomp:
            print('  {}'.format(item))
        ret = []
    else:
        cobj = SymProject.load(allcomps[lstcomp[0]])
        unresolved = cobj.getParam()[0].getUnresolvedImports()

        print('Unresolved imports: {}, unresolved exports: {}'.format(len(unresolved),
                                                                      len(cobj.getParam()[0].getUnresolvedExports())))
        if not unresolved:
            print('Not unresolved')
            ret = [prj]
        else:

            # Unresolved
            # for item in unresolved:
            #     print('Unresolved {}'.format(item[1].getParamName()))
            #
            scorelst = []
            testpar = SymLinkedField('__test__', 'Test parameter')
            testUnresolved(prj, testpar, unresolved, scorelst)
            testpar.removeParam()

            if len(scorelst) > 0:
                maxdepth = max([i[2] for i in scorelst])
                score = [i[1] * (maxdepth + 1) + maxdepth - i[2] for i in scorelst]
                hiscore = max(score)
                print('Hi score: {} count: {}'.format(hiscore, score.count(hiscore)))

                ret = []
                for i in range(len(score)):
                    if score[i] == hiscore:
                        ret.append(scorelst[i])
            else:
                print('No matching found, {} unresolved parameter(s)'.format(len(unresolved)))
                ret = []

        if len(ret) == 1:
            print('\n\n========== ADD COMPONENT =========\n    {}'.format(ret[0][0].getIdentifier()))

            if ret[0][1] == len(unresolved):
                print('    --> All imports resolved!')
            else:
                print('    WARNING: {} import(s) unresolved'.format(len(unresolved) - ret[0][1]))

    return ret
